===> Generating patch
===> Viewing diff with more
diff -ruN --exclude=CVS /usr/ports/net/asterisk/Makefile /usr/home/viper/net/asterisk/Makefile
--- /usr/ports/net/asterisk/Makefile	Wed May 30 02:52:15 2007
+++ /usr/home/viper/net/asterisk/Makefile	Wed Jul  4 17:20:29 2007
@@ -6,8 +6,7 @@
 #
 
 PORTNAME=	asterisk
-PORTVERSION=	1.4.4
-PORTREVISION=	2
+PORTVERSION=	1.4.6
 CATEGORIES=	net
 MASTER_SITES=	http://ftp.digium.com/pub/asterisk/ \
 		http://ftp.digium.com/pub/asterisk/old-releases/
@@ -24,7 +23,7 @@
 ONLY_FOR_ARCHS=	i386 sparc64 amd64
 
 GNU_CONFIGURE=	yes
-CONFIGURE_ARGS= --mandir=${LOCALBASE}/man
+CONFIGURE_ARGS=	--mandir=${LOCALBASE}/man
 CONFIGURE_ENV=	CPPFLAGS="-I${LOCALBASE}/include" \
 		LDFLAGS="-L${LOCALBASE}/lib"
 USE_GMAKE=	yes
@@ -51,27 +50,27 @@
 .include <bsd.port.pre.mk>
 
 .if ${ARCH} == "i386"
-OPTIONS+=	ZAPTEL		"Enable Zaptel support" on
+OPTIONS+=	ZAPTEL          "Enable Zaptel hardware support" on
 .else
-WITHOUT_ZAPTEL=	yes
+WITHOUT_ZAPTEL=yes
 .endif
 
 .if defined(WITHOUT_H323)
 PLIST_SUB+=	WITH_H323="@comment "
-CONFIGURE_ARGS+= --without-h323
+CONFIGURE_ARGS+=--without-h323
 .else
 PLIST_SUB+=	WITH_H323=""
-CONFIGURE_ARGS+= --with-h323
+CONFIGURE_ARGS+=--with-h323
 LIB_DEPENDS+=	pt_r.1:${PORTSDIR}/devel/pwlib \
 		h323_r.1:${PORTSDIR}/net/openh323
 .endif
 
 .if defined(WITHOUT_ZAPTEL)
 PLIST_SUB+=	WITH_ZAPTEL="@comment "
-CONFIGURE_ARGS+= --without-zaptel
+CONFIGURE_ARGS+=--without-zaptel
 .else
 PLIST_SUB+=	WITH_ZAPTEL=""
-CONFIGURE_ARGS+= --with-zaptel
+CONFIGURE_ARGS+=--with-zaptel
 BUILD_DEPENDS+=	libpri>=1.2.0:${PORTSDIR}/misc/libpri \
 		${LOCALBASE}/include/zaptel/zaptel.h:${PORTSDIR}/misc/zaptel
 LIB_DEPENDS+=	pri.1:${PORTSDIR}/misc/libpri
@@ -83,68 +82,68 @@
 # similarly
 .if defined(WITHOUT_ODBC)
 PLIST_SUB+=	WITH_ODBC="@comment "
-CONFIGURE_ARGS+= --without-odbc
+CONFIGURE_ARGS+=--without-odbc
 .else
 PLIST_SUB+=	WITH_ODBC=""
-CONFIGURE_ARGS+= --with-odbc
+CONFIGURE_ARGS+=--with-odbc
 LIB_DEPENDS+=	odbc.1:${PORTSDIR}/databases/unixODBC
 .endif
 
 .if defined(WITHOUT_FREETDS)
 PLIST_SUB+=	WITH_FREETDS="@comment "
-CONFIGURE_ARGS+= --without-tds
+CONFIGURE_ARGS+=--without-tds
 .else
 PLIST_SUB+=	WITH_FREETDS=""
-CONFIGURE_ARGS+= --with-tds=${LOCALBASE}
+CONFIGURE_ARGS+=--with-tds=${LOCALBASE}
 LIB_DEPENDS+=	tds.5:${PORTSDIR}/databases/freetds
 .endif
 
 .if defined(WITHOUT_POSTGRES)
 PLIST_SUB+=	WITH_POSTGRES="@comment "
-CONFIGURE_ARGS+= --without-postgres
+CONFIGURE_ARGS+=--without-postgres
 .else
 PLIST_SUB+=	WITH_POSTGRES=""
 USE_PGSQL=	yes
-CONFIGURE_ARGS+= --with-postgres
+CONFIGURE_ARGS+=--with-postgres
 .endif
 
 .if defined(WITHOUT_OGGVORBIS)
 PLIST_SUB+=	WITH_OGGVORBIS="@comment "
-CONFIGURE_ARGS+= --without-ogg
+CONFIGURE_ARGS+=--without-ogg
 .else
 PLIST_SUB+=	WITH_OGGVORBIS=""
-CONFIGURE_ARGS+= --with-ogg
+CONFIGURE_ARGS+=--with-ogg
 LIB_DEPENDS+=	vorbis.3:${PORTSDIR}/audio/libvorbis
 .endif
 
 .if defined(WITHOUT_RADIUS)
 PLIST_SUB+=	WITH_RADIUS="@comment "
-CONFIGURE_ARGS+= --without-radius
+CONFIGURE_ARGS+=--without-radius
 .else
 PLIST_SUB+=	WITH_RADIUS=""
-CONFIGURE_ARGS+= --with-radius
+CONFIGURE_ARGS+=--with-radius
 LIB_DEPENDS+=	radiusclient-ng.2:${PORTSDIR}/net/radiusclient
 .endif
 
 .if defined(WITHOUT_SNMP)
 PLIST_SUB+=	WITH_SNMP="@comment "
-CONFIGURE_ARGS+= --without-netsnmp
+CONFIGURE_ARGS+=--without-netsnmp
 .else
 PLIST_SUB+=	WITH_SNMP=""
-CONFIGURE_ARGS+= --with-netsnmp
+CONFIGURE_ARGS+=--with-netsnmp
 LIB_DEPENDS+=	netsnmp.10:${PORTSDIR}/net-mgmt/net-snmp
 .endif
 
 .if defined(WITHOUT_JABBER)
 PLIST_SUB+=	WITH_JABBER="@comment "
-CONFIGURE_ARGS+= --without-iksemel
+CONFIGURE_ARGS+=--without-iksemel
 .else
 PLIST_SUB+=	WITH_JABBER=""
-CONFIGURE_ARGS+= --with-iksemel
+CONFIGURE_ARGS+=--with-iksemel
 LIB_DEPENDS+=	iksemel.3:${PORTSDIR}/textproc/iksemel
 .endif
 
 post-patch:
-	${REINPLACE_CMD} -e 's|/var/lib|${PREFIX}/share|g' ${WRKSRC}/configs/musiconhold.conf.sample
+	@${REINPLACE_CMD} -e 's|/var/lib|${PREFIX}/share|g' ${WRKSRC}/configs/musiconhold.conf.sample
 
 .include <bsd.port.post.mk>
diff -ruN --exclude=CVS /usr/ports/net/asterisk/distinfo /usr/home/viper/net/asterisk/distinfo
--- /usr/ports/net/asterisk/distinfo	Tue May 29 00:16:35 2007
+++ /usr/home/viper/net/asterisk/distinfo	Wed Jul  4 17:05:17 2007
@@ -1,3 +1,3 @@
-MD5 (asterisk-1.4.4.tar.gz) = 90f6a2ea5113ad26de393517576a1ede
-SHA256 (asterisk-1.4.4.tar.gz) = 82a28d8f511703de5fc6231123f15a7c2fbda54ff9c0a686e405f74d1c03aca7
-SIZE (asterisk-1.4.4.tar.gz) = 17081631
+MD5 (asterisk-1.4.6.tar.gz) = 579b154c9045a69945b8547e590c25a1
+SHA256 (asterisk-1.4.6.tar.gz) = f15bb0a6e23e9e2952248917098beeedf9f3333cf2f3ad77e46996ce8298c934
+SIZE (asterisk-1.4.6.tar.gz) = 11157378
diff -ruN --exclude=CVS /usr/ports/net/asterisk/files/patch-Makefile /usr/home/viper/net/asterisk/files/patch-Makefile
--- /usr/ports/net/asterisk/files/patch-Makefile	Mon Apr 16 14:40:15 2007
+++ /usr/home/viper/net/asterisk/files/patch-Makefile	Wed Jul  4 16:57:47 2007
@@ -1,9 +1,6 @@
-
-$FreeBSD: ports/net/asterisk/files/patch-Makefile,v 1.19 2007/04/16 08:40:15 sobomax Exp $
-
---- Makefile.orig
-+++ Makefile
-@@ -207,7 +207,7 @@
+--- Makefile.orig	Tue Jun 19 11:06:33 2007
++++ Makefile	Tue Jun 19 11:46:29 2007
+@@ -209,7 +209,7 @@
  
  ifeq ($(OSARCH),FreeBSD)
    # -V is understood by BSD Make, not by GNU make.
@@ -12,7 +9,7 @@
    ASTCFLAGS+=$(shell if test $(BSDVERSION) -lt 500016 ; then echo "-D_THREAD_SAFE"; fi)
    AST_LIBS+=$(shell if test  $(BSDVERSION) -lt 502102 ; then echo "-lc_r"; else echo "-pthread"; fi)
  endif
-@@ -371,15 +371,15 @@
+@@ -374,15 +374,15 @@
  # Should static HTTP be installed during make samples or even with its own target ala
  # webvoicemail?  There are portions here that *could* be customized but might also be
  # improved a lot.  I'll put it here for now.
@@ -33,7 +30,7 @@
  	$(MAKE) -C sounds install
  
  update: 
-@@ -400,45 +400,45 @@
+@@ -403,45 +403,45 @@
  OLDHEADERS=$(filter-out $(NEWHEADERS),$(notdir $(wildcard $(DESTDIR)$(ASTHEADERDIR)/*.h)))
  
  bininstall: _all
@@ -67,7 +64,7 @@
 +	$(BSD_INSTALL_SCRIPT) contrib/scripts/astgenkey $(DESTDIR)$(ASTSBINDIR)/
 +	$(BSD_INSTALL_SCRIPT) contrib/scripts/autosupport $(DESTDIR)$(ASTSBINDIR)/
  	if [ ! -f $(DESTDIR)$(ASTSBINDIR)/safe_asterisk ]; then \
- 		cat contrib/scripts/safe_asterisk | sed 's|__ASTERISK_SBIN_DIR__|$(ASTSBINDIR)|;' > $(DESTDIR)$(ASTSBINDIR)/safe_asterisk ;\
+ 		cat contrib/scripts/safe_asterisk | sed 's|__ASTERISK_SBIN_DIR__|$(ASTSBINDIR)|;s|__ASTERISK_VARRUN_DIR__|$(ASTVARRUNDIR)|;' > $(DESTDIR)$(ASTSBINDIR)/safe_asterisk ;\
  		chmod 755 $(DESTDIR)$(ASTSBINDIR)/safe_asterisk;\
  	fi
 -	$(INSTALL) -d $(DESTDIR)$(ASTHEADERDIR)
@@ -109,7 +106,7 @@
  	fi
  
  $(SUBDIRS_INSTALL):
-@@ -465,7 +465,7 @@
+@@ -468,7 +468,7 @@
  		echo " WARNING WARNING WARNING" ;\
  	fi
  
@@ -118,7 +115,7 @@
  	@if [ -x /usr/sbin/asterisk-post-install ]; then \
  		/usr/sbin/asterisk-post-install $(DESTDIR) . ; \
  	fi
-@@ -495,31 +495,23 @@
+@@ -498,31 +498,23 @@
  upgrade: bininstall
  
  adsi:
@@ -158,7 +155,7 @@
  		( \
  		echo "[directories]" ; \
  		echo "astetcdir => $(ASTETCDIR)" ; \
-@@ -540,20 +532,23 @@
+@@ -543,20 +535,23 @@
  		echo ";astctlowner = root" ; \
  		echo ";astctlgroup = apache" ; \
  		echo ";astctl = asterisk.ctl" ; \
@@ -186,7 +183,7 @@
  	done
  	@echo " +--------- Asterisk Web Voicemail ----------+"  
  	@echo " +                                           +"
-@@ -580,10 +575,10 @@
+@@ -583,10 +578,10 @@
  
  __rpm: include/asterisk/version.h include/asterisk/buildopts.h spec
  	rm -rf /tmp/asterisk ; \
@@ -199,7 +196,7 @@
  	cp -f contrib/init.d/rc.redhat.asterisk /tmp/asterisk/etc/rc.d/init.d/asterisk ; \
  	rpmbuild --rcfile /usr/lib/rpm/rpmrc:redhat/rpmrc -bb asterisk.spec
  
-@@ -594,19 +589,19 @@
+@@ -597,19 +592,19 @@
  config:
  	@if [ "${OSARCH}" = "linux-gnu" ]; then \
  		if [ -f /etc/redhat-release -o -f /etc/fedora-release ]; then \
diff -ruN --exclude=CVS /usr/ports/net/asterisk/files/patch-configure /usr/home/viper/net/asterisk/files/patch-configure
--- /usr/ports/net/asterisk/files/patch-configure	Fri Apr 13 14:06:05 2007
+++ /usr/home/viper/net/asterisk/files/patch-configure	Wed Jul  4 17:10:15 2007
@@ -3,24 +3,6 @@
 
 --- configure.orig
 +++ configure
-@@ -23776,7 +23776,7 @@
-   echo $ECHO_N "(cached) $ECHO_C" >&6
- else
-   ac_check_lib_save_LIBS=$LIBS
--LIBS="-lodbc ${pbxlibdir} -lltdl $LIBS"
-+LIBS="-lodbc ${pbxlibdir} $LIBS"
- cat >conftest.$ac_ext <<_ACEOF
- /* confdefs.h.  */
- _ACEOF
-@@ -23855,7 +23855,7 @@
- 
- 
-    if test "${AST_UNIXODBC_FOUND}" = "yes"; then
--      UNIXODBC_LIB="-lodbc -lltdl"
-+      UNIXODBC_LIB="-lodbc"
-       UNIXODBC_HEADER_FOUND="1"
-       if test "x${UNIXODBC_DIR}" != "x"; then
-          UNIXODBC_LIB="${pbxlibdir} ${UNIXODBC_LIB}"
 @@ -28065,7 +28065,7 @@
  
  	fi
diff -ruN --exclude=CVS /usr/ports/net/asterisk/pkg-plist /usr/home/viper/net/asterisk/pkg-plist
--- /usr/ports/net/asterisk/pkg-plist	Tue May 29 02:21:08 2007
+++ /usr/home/viper/net/asterisk/pkg-plist	Wed Jul  4 16:57:47 2007
@@ -76,6 +76,8 @@
 etc/asterisk/queues.conf-dist
 @unexec if cmp -s %D/etc/asterisk/res_odbc.conf %D/etc/asterisk/res_odbc.conf-dist; then rm -f %D/etc/asterisk/res_odbc.conf; fi
 etc/asterisk/res_odbc.conf-dist
+@unexec if cmp -s %D/etc/asterisk/res_pgsql.conf %D/etc/asterisk/res_pgsql.conf-dist; then rm -f %D/etc/asterisk/res_pgsql.conf; fi
+etc/asterisk/res_pgsql.conf-dist
 @unexec if cmp -s %D/etc/asterisk/rpt.conf %D/etc/asterisk/rpt.conf-dist; then rm -f %D/etc/asterisk/rpt.conf; fi
 etc/asterisk/rpt.conf-dist
 @unexec if cmp -s %D/etc/asterisk/rtp.conf %D/etc/asterisk/rtp.conf-dist; then rm -f %D/etc/asterisk/rtp.conf; fi
@@ -280,7 +282,6 @@
 %%WITH_POSTGRES%%lib/asterisk/modules/cdr_pgsql.so
 %%WITH_RADIUS%%lib/asterisk/modules/cdr_radius.so
 lib/asterisk/modules/chan_agent.so
-lib/asterisk/modules/chan_features.so
 %%WITH_JABBER%%lib/asterisk/modules/chan_gtalk.so
 lib/asterisk/modules/chan_iax2.so
 lib/asterisk/modules/chan_local.so
@@ -378,8 +379,8 @@
 share/asterisk/moh/fpm-calm-river.wav
 share/asterisk/moh/fpm-sunshine.wav
 share/asterisk/moh/fpm-world-mix.wav
-share/asterisk/sounds/.asterisk-core-sounds-en-gsm-1.4.6
-share/asterisk/sounds/CREDITS-asterisk-core-en-1.4.6
+share/asterisk/sounds/.asterisk-core-sounds-en-gsm-1.4.7
+share/asterisk/sounds/CREDITS-asterisk-core-en-1.4.7
 share/asterisk/sounds/agent-alreadyon.gsm
 share/asterisk/sounds/agent-incorrect.gsm
 share/asterisk/sounds/agent-loggedoff.gsm
@@ -749,7 +750,6 @@
 share/asterisk/sounds/vm-unknown-caller.gsm
 share/asterisk/sounds/vm-whichbox.gsm
 share/asterisk/sounds/vm-youhave.gsm
-share/asterisk/sounds/x
 share/asterisk/static-http/ajamdemo.html
 share/asterisk/static-http/astman.css
 share/asterisk/static-http/astman.js
===> Done