--- asterisk-1.6.0-beta5.orig/configs/res_ldap.conf.sample	2008-01-23 00:33:20.000000000 +0200
+++ asterisk-1.6.0-beta5/configs/res_ldap.conf.sample	2008-03-17 14:38:14.130655167 +0200
@@ -44,61 +44,62 @@
 ; Sip Users Table
 [sip]
 name = uid
-amaflags = PBXAccountAMAFlags
-callgroup = PBXAccountCallGroup
-callerid = PBXAccountCallerID
-canreinvite = PBXAccountCanReinvite
-context = PBXAccountContext
-dtmfmode = PBXAccountDTMFMode
-fromuser = PBXAccountFromUser
-fromdomain = PBXAccountFromDomain
-fullcontact = PBXAccountFullContact
-fullcontact = gecos
-host = PBXAccountHost
-insecure = PBXAccountInsecure
-mailbox = PBXAccountMailbox
-md5secret = realmedPassword
-nat = PBXAccountNAT
-deny = PBXAccountDeny
-permit = PBXAccountPermit
-pickupgroup = PBXAccountPickupGroup
-port = PBXAccountPort
-qualify = PBXAccountQualify
-restrictcid = PBXAccountRestrictCID
-rtptimeout = PBXAccountRTPTimeout
-rtpholdtimeout = PBXAccountRTPHoldTimeout
-type = PBXAccountType
-disallow = PBXAccountDisallowedCodec
-allow = PBXAccountAllowedCodec
-MusicOnHold = PBXAccountMusicOnHold
-regseconds = PBXAccountExpirationTimestamp
-regcontext = PBXAccountRegistrationContext
-regexten = PBXAccountRegistrationExten
-CanCallForward = PBXAccountCanCallForward
-additionalFilter=(objectClass=PBXAccountSIP)
+amaflags = AstAccountAMAFlags
+callgroup = AstAccountCallGroup
+callerid = cn
+canreinvite = AstAccountCanReinvite
+context = AstAccountContext
+dtmfmode = AstAccountDTMFMode
+fromuser = AstAccountFromUser
+fromdomain = AstAccountFromDomain
+fullcontact = AstAccountFullContact
+host = AstAccountHost
+insecure = AstAccountInsecure
+mailbox = AstAccountMailbox
+md5secret = AstAccountRealmedPassword
+nat = AstAccountNAT
+deny = AstAccountDeny
+permit = AstAccountPermit
+pickupgroup = AstAccountPickupGroup
+port = AstAccountPort
+qualify = AstAccountQualify
+restrictcid = AstAccountRestrictCID
+rtptimeout = AstAccountRTPTimeout
+rtpholdtimeout = AstAccountRTPHoldTimeout
+type = AstAccountType
+disallow = AstAccountDisallowedCodec
+allow = AstAccountAllowedCodec
+MusicOnHold = AstAccountMusicOnHold
+regseconds = AstAccountExpirationTimestamp
+regcontext = AstAccountRegistrationContext
+regexten = AstAccountRegistrationExten
+CanCallForward = AstAccountCanCallForward
+ipaddr = AstAccountIPAddress
+defaultuser = AstAccountDefaultUser
+regserver = AstAccountRegistrationServer
+additionalFilter=(objectClass=AsteriskSIPUser)
 
 ; IAX Users Table
 [iax]
-amaflags = PBXAccountAMAFlags
-callerid = PBXAccountCallerID
-context = PBXAccountContext
-fullcontact = PBXAccountFullContact
-fullcontact = gecos
-host = PBXAccountHost
-mailbox = PBXAccountMailbox
-md5secret = realmedPassword
-deny = PBXAccountDeny
-permit = PBXAccountPermit
-port = PBXAccountPort
-qualify = PBXAccountQualify
-type = PBXAccountType
-disallow = PBXAccountDisallowedCodec
-allow = PBXAccountAllowedCodec
-regseconds = PBXAccountExpirationTimestamp
-regcontext = PBXAccountRegistrationContext
-regexten = PBXAccountRegistrationExten
-notransfer = PBXAccountNoTransfer
-additionalFilter=(objectClass=PBXAccountIAX)
+amaflags = AstAccountAMAFlags
+callerid = AstAccountCallerID
+context = AstAccountContext
+fullcontact = AstAccountFullContact
+host = AstAccountHost
+mailbox = AstAccountMailbox
+md5secret = AstAccountRealmedPassword
+deny = AstAccountDeny
+permit = AstAccountPermit
+port = AstAccountPort
+qualify = AstAccountQualify
+type = AstAccountType
+disallow = AstAccountDisallowedCodec
+allow = AstAccountAllowedCodec
+regseconds = AstAccountExpirationTimestamp
+regcontext = AstAccountRegistrationContext
+regexten = AstAccountRegistrationExten
+notransfer = AstAccountNoTransfer
+additionalFilter=(objectClass=AstAccountIAX)
 
 ; A Test Family
 [testfamily]
@@ -106,36 +107,35 @@
 additionalFilter=(objectClass=*)
 
 [accounts]
-amaflags = PBXAccountAMAFlags
-callgroup = PBXAccountCallGroup
-callerid = PBXAccountCallerID
-canreinvite = PBXAccountCanReinvite
-context = PBXAccountContext
-dtmfmode = PBXAccountDTMFMode
-fromuser = PBXAccountFromUser
-fromdomain = PBXAccountFromDomain
-fullcontact = PBXAccountFullContact
-fullcontact = gecos
-host = PBXAccountHost
-insecure = PBXAccountInsecure
-mailbox = PBXAccountMailbox
-md5secret = realmedPassword
-nat = PBXAccountNAT
-deny = PBXAccountDeny
-permit = PBXAccountPermit
-pickupgroup = PBXAccountPickupGroup
-port = PBXAccountPort
-qualify = PBXAccountQualify
-restrictcid = PBXAccountRestrictCID
-rtptimeout = PBXAccountRTPTimeout
-rtpholdtimeout = PBXAccountRTPHoldTimeout
-type = PBXAccountType
-disallow = PBXAccountDisallowedCodec
-allow = PBXAccountAllowedCodec
-MusicOnHold = PBXAccountMusicOnHold
-regseconds = PBXAccountExpirationTimestamp
-regcontext = PBXAccountRegistrationContext
-regexten = PBXAccountRegistrationExten
-CanCallForward = PBXAccountCanCallForward
-additionalFilter=(objectClass=PBXAccount)
+amaflags = AstAccountAMAFlags
+callgroup = AstAccountCallGroup
+callerid = AstAccountCallerID
+canreinvite = AstAccountCanReinvite
+context = AstAccountContext
+dtmfmode = AstAccountDTMFMode
+fromuser = AstAccountFromUser
+fromdomain = AstAccountFromDomain
+fullcontact = AstAccountFullContact
+host = AstAccountHost
+insecure = AstAccountInsecure
+mailbox = AstAccountMailbox
+md5secret = AstAccountRealmedPassword
+nat = AstAccountNAT
+deny = AstAccountDeny
+permit = AstAccountPermit
+pickupgroup = AstAccountPickupGroup
+port = AstAccountPort
+qualify = AstAccountQualify
+restrictcid = AstAccountRestrictCID
+rtptimeout = AstAccountRTPTimeout
+rtpholdtimeout = AstAccountRTPHoldTimeout
+type = AstAccountType
+disallow = AstAccountDisallowedCodec
+allow = AstAccountAllowedCodec
+MusicOnHold = AstAccountMusicOnHold
+regseconds = AstAccountExpirationTimestamp
+regcontext = AstAccountRegistrationContext
+regexten = AstAccountRegistrationExten
+CanCallForward = AstAccountCanCallForward
+additionalFilter=(objectClass=AstAccount)
 